/*-
 * Copyright (c) 2017-2020 Carsten Sonne Larsen <cs@innolan.net>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

#ifndef MESSAGE_H_INCLUDED
#define MESSAGE_H_INCLUDED

#include "config.h"

#define MSGTYPE_APP 1
#define MSGTYPE_TIMEVAL 2

#define ATK_LASTSYNC 1
#define ATK_RESTART 10
#define ATK_REFRESH 11
#define ATK_STORE 13
#define ATK_APPLY 14
#define ATK_UNDO 15
#define ATK_ENABLE 20
#define ATK_DISABLE 21
#define ATK_READONLY 22
#define ATK_READWRITE 23
#define ATK_SHUTDOWN 30
#define ATK_TZ_CHANGED 40
#define ATK_TZONE_CHANGED 41
#define ATK_LOCALE_CHANGED 42

struct ApplicationMesage
{
    struct Message Msg;
    long MsgType;
    long MsgId;
};

struct TimeMessage
{
    struct ApplicationMesage AppMsg;
    struct timeval TimeVal;
};

void SendMessage(long);
void SendMessageTo(struct MsgPort *, struct MsgPort *, long);
void SendMessageWait(struct MsgPort *, long);
void CleanupMsgPort(struct MsgPort **);
void CleanupVolMsgPort(struct MsgPort *volatile *);
#endif
